/*
 * main.c - WiFi manager main
 *
 * Copyright (C) 2019 iopsys Software Solutions AB. All rights reserved.
 *
 * Author: Anjan Chanda <anjan.chanda@iopsys.eu>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif

#include <json-c/json.h>
#include <libubox/blobmsg.h>
#include <libubox/blobmsg_json.h>
#include <libubox/uloop.h>
#include <libubox/ustream.h>
#include <libubox/utils.h>
#include <libubus.h>

#include <easy/easy.h>
#include <wifi.h>
#include "wifimngr.h"


int main(int argc, char **argv)
{
	struct wifimngr_cmdline_opts opts = {
		.ubus_socket = NULL,
		.evmap_file = DEFAULT_WIFI_EVMAP_JSON_FILE,
		.conffile = DEFAULT_WIFI_CONFFILE,
	};
	int ch;

	while ((ch = getopt(argc, argv, "vhs:e:")) != -1) {
		switch (ch) {
		case 'v':
			wifimngr_version();
			exit(0);
		case 's':
			opts.ubus_socket = optarg;
			break;
		case 'e':
			opts.evmap_file = optarg;
			break;
		default:
			break;
		}
	}

	wifimngr_main(&opts);

	return 0;
}
